import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.JPasswordField;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;

import SecureBlackbox.FTPSClient.SBSimpleFTPS;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ConnDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbUser;
	private JPasswordField tbPassword;
	private JTextField tbCertPath;
	private JPasswordField tbCertPwd;
	protected boolean isOk;
	private JTextField tbHost;
	private JSpinner tbPort;
	private JCheckBox cbUseSsltls;
	private JCheckBox cbUseClearData;
	private JComboBox<String> cmbAuth;
	private JCheckBox chckbxSsl2;
	private JCheckBox chckbxSsl3;
	private JCheckBox chckbxTls1;
	private JCheckBox chckbxTls11;
	private JCheckBox chckbxTls12;
	private JButton btnBrowse;
	private JCheckBox chckbxUseImplicitSsl;
	private JCheckBox chckbxPassiveFtpMode;
	private JCheckBox chckbxStrictServerCertificate;
	private JButton okButton;
	private JButton cancelButton;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ConnDialog dialog = new ConnDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ConnDialog() {
		setTitle("Connection properties");
		setBounds(100, 100, 450, 443);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JPanel panel = new JPanel();
			panel.setBorder(new TitledBorder(null, "Connection properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
			panel.setBounds(10, 11, 359, 342);
			contentPanel.add(panel);
			panel.setLayout(null);
			{
				JLabel lblHost = new JLabel("Host");
				lblHost.setBounds(10, 21, 46, 14);
				panel.add(lblHost);
			}
			{
				tbHost = new JTextField();
				tbHost.setText("127.0.0.1");
				tbHost.setBounds(10, 40, 255, 20);
				panel.add(tbHost);
				tbHost.setColumns(10);
			}
			
			tbPort = new JSpinner();
			tbPort.setModel(new SpinnerNumberModel(new Integer(21), null, null, new Integer(1)));
			tbPort.setBounds(275, 40, 74, 20);
			panel.add(tbPort);
			
			JLabel lblPort = new JLabel("Port");
			lblPort.setBounds(275, 21, 46, 14);
			panel.add(lblPort);
			
			JLabel lblUsername = new JLabel("Username");
			lblUsername.setBounds(10, 71, 84, 14);
			panel.add(lblUsername);
			
			tbUser = new JTextField();
			tbUser.setText("anonymous");
			tbUser.setBounds(8, 88, 158, 20);
			panel.add(tbUser);
			tbUser.setColumns(10);
			
			JLabel lblPassword = new JLabel("Password");
			lblPassword.setBounds(191, 71, 98, 14);
			panel.add(lblPassword);
			
			tbPassword = new JPasswordField();
			tbPassword.setBounds(191, 88, 158, 20);
			panel.add(tbPassword);
			
			cbUseSsltls = new JCheckBox("Use SSL/TLS");
			cbUseSsltls.setBounds(10, 115, 101, 23);
			panel.add(cbUseSsltls);
			
			cbUseClearData = new JCheckBox("Use clear data channel");
			cbUseClearData.setBounds(191, 115, 162, 23);
			panel.add(cbUseClearData);
			
			JLabel lblAuthCommand = new JLabel("Auth command");
			lblAuthCommand.setBounds(10, 145, 101, 14);
			panel.add(lblAuthCommand);
			
			cmbAuth = new JComboBox<String>();
			cmbAuth.setModel(new DefaultComboBoxModel<String>(new String[] {"Autodetect", "AUTH TLS", "AUTH SSL", "AUTH TLS-P", "AUTH TLS-C"}));
			cmbAuth.setBounds(129, 141, 98, 22);
			panel.add(cmbAuth);
			
			chckbxSsl2 = new JCheckBox("SSL2");
			chckbxSsl2.setBounds(10, 176, 74, 23);
			panel.add(chckbxSsl2);
			
			chckbxSsl3 = new JCheckBox("SSL3");
			chckbxSsl3.setBounds(65, 176, 74, 23);
			panel.add(chckbxSsl3);
			
			chckbxTls1 = new JCheckBox("TLS1");
			chckbxTls1.setSelected(true);
			chckbxTls1.setBounds(140, 176, 67, 23);
			panel.add(chckbxTls1);
			
			chckbxTls11 = new JCheckBox("TLS 1.1");
			chckbxTls11.setSelected(true);
			chckbxTls11.setBounds(208, 176, 74, 23);
			panel.add(chckbxTls11);
			
			chckbxTls12 = new JCheckBox("TLS 1.2");
			chckbxTls12.setSelected(true);
			chckbxTls12.setBounds(282, 176, 74, 23);
			panel.add(chckbxTls12);
			
			JLabel lblUseCertificatepfx = new JLabel("Use certificate (PFX format assumed)");
			lblUseCertificatepfx.setBounds(10, 206, 236, 14);
			panel.add(lblUseCertificatepfx);
			
			tbCertPath = new JTextField();
			tbCertPath.setBounds(10, 222, 293, 20);
			panel.add(tbCertPath);
			tbCertPath.setColumns(10);
			
			btnBrowse = new JButton("...");
			btnBrowse.setBounds(307, 221, 42, 23);
			panel.add(btnBrowse);
			
			JLabel label = new JLabel("Password");
			label.setBounds(10, 259, 98, 14);
			panel.add(label);
			
			tbCertPwd = new JPasswordField();
			tbCertPwd.setBounds(86, 253, 158, 20);
			panel.add(tbCertPwd);
			
			chckbxUseImplicitSsl = new JCheckBox("Use implicit SSL");
			chckbxUseImplicitSsl.setBounds(10, 280, 133, 23);
			panel.add(chckbxUseImplicitSsl);
			
			chckbxPassiveFtpMode = new JCheckBox("Passive FTP mode");
			chckbxPassiveFtpMode.setBounds(145, 280, 158, 23);
			panel.add(chckbxPassiveFtpMode);
			
			chckbxStrictServerCertificate = new JCheckBox("Strict server certificate validation");
			chckbxStrictServerCertificate.setBounds(10, 306, 255, 23);
			panel.add(chckbxStrictServerCertificate);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public boolean isOK() {
		return isOk;
	}

	public String getCertText() {
		return tbCertPath.getText();
	}

	public String getHost() {
		return tbHost.getText();
	}

	public int getPort() {
		return (Integer)tbPort.getValue();
	}

	public String getUsername() {
		return tbUser.getText();
	}

	public String getPassword() {
		return new String(tbPassword.getPassword());
	}

	public boolean getSSL2() {
		return chckbxSsl2.isSelected();
	}

	public boolean getTLS1() {
		return chckbxTls1.isSelected();
	}

	public boolean getSSL3() {
		return chckbxSsl3.isSelected();
	}

	public boolean getTLS11() {
		return chckbxTls11.isSelected();
	}
	
	public boolean getTLS12() {
		return chckbxTls12.isSelected();
	}

	public String getCertPassword() {
		return new String(tbCertPwd.getPassword());
	}

	public boolean getUseSSL() {
		return cbUseSsltls.isSelected();
	}

	public boolean getClear() {
		return cbUseClearData.isSelected();
	}

	public short getAuthCmd() {
		if (cmbAuth.getSelectedIndex() == -1)
			return SBSimpleFTPS.acAuto;
		
		return (short) cmbAuth.getSelectedIndex();
	}

	public boolean getImplicit() {
		return chckbxUseImplicitSsl.isSelected();
	}

	public boolean getPassive() {
		return chckbxPassiveFtpMode.isSelected();
	}
}
