

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.util.Hashtable;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JSlider;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

import javax.swing.JCheckBox;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import SecureBlackbox.Base.*;
import SecureBlackbox.MIME.*;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField edtGranularity;
	private JTextField edtNotes;
	private JLabel lblPublicKeySize;
	private JSlider trkPublicKeySize;
	private JTextField edtDNSRecord;
	private JTextArea memPrivateKey;
	private JButton btnRevoke;
	private JButton btnCopyDNSRecord;
	private JCheckBox cbTestMode;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			Main dialog = new Main();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setTitle("Domain Keys DNS Demo");
		setBounds(100, 100, 443, 458);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JLabel lblGranularityoptional = new JLabel("Granularity (optional):");
		lblGranularityoptional.setBounds(10, 11, 125, 14);
		contentPanel.add(lblGranularityoptional);
		
		JLabel lblNotesoptional = new JLabel("Notes (optional):");
		lblNotesoptional.setBounds(10, 36, 131, 14);
		contentPanel.add(lblNotesoptional);
		
		edtGranularity = new JTextField();
		edtGranularity.setBounds(165, 8, 259, 20);
		contentPanel.add(edtGranularity);
		edtGranularity.setColumns(10);
		
		edtNotes = new JTextField();
		edtNotes.setColumns(10);
		edtNotes.setBounds(165, 33, 259, 20);
		contentPanel.add(edtNotes);
		
		lblPublicKeySize = new JLabel("Public Key Size (bits) : 256");
		lblPublicKeySize.setBounds(10, 76, 165, 14);
		contentPanel.add(lblPublicKeySize);
		
		trkPublicKeySize = new JSlider(JSlider.HORIZONTAL);

		trkPublicKeySize.setMinimum(256);
	    trkPublicKeySize.setMaximum(4096);

		trkPublicKeySize.setMinorTickSpacing(256); // step
	    	    
	    trkPublicKeySize.setPaintLabels(true);
	    trkPublicKeySize.setSnapToTicks(true);
	    trkPublicKeySize.setPaintTicks(true);
		
	    fillSlider();
	    
	    trkPublicKeySize.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
	            JSlider d = (JSlider) e.getSource();
	            if (!d.getValueIsAdjusting()) {

					lblPublicKeySize.setText("Public Key Size (bits) : " + (d.getValue()));
	            }
	        }
	    });
	    
		trkPublicKeySize.setBounds(185, 64, 239, 40);
		contentPanel.add(trkPublicKeySize);
		
		cbTestMode = new JCheckBox("Use test mode");
		cbTestMode.setBounds(6, 97, 118, 23);
		contentPanel.add(cbTestMode);
		
		JButton btnGenerate = new JButton("Generate Private Key and DNS Record");
		btnGenerate.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				generateClick();
			}
		});
		btnGenerate.setBounds(10, 127, 414, 23);
		contentPanel.add(btnGenerate);
		
		btnRevoke = new JButton("Revoke Private Key and DNS Record");
		btnRevoke.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				revokeClick();
			}
		});
		btnRevoke.setBounds(10, 161, 414, 23);
		contentPanel.add(btnRevoke);
		
		JLabel lblDnsRecord = new JLabel("DNS Record:");
		lblDnsRecord.setBounds(10, 195, 84, 14);
		contentPanel.add(lblDnsRecord);
		
		edtDNSRecord = new JTextField();
		edtDNSRecord.setBounds(10, 212, 414, 20);
		contentPanel.add(edtDNSRecord);
		edtDNSRecord.setColumns(10);
		
		JLabel lblPrivateKeyTo = new JLabel("Private Key to use to sign e-mail messages:");
		lblPrivateKeyTo.setBounds(10, 243, 247, 14);
		contentPanel.add(lblPrivateKeyTo);
		
		btnCopyDNSRecord = new JButton("Copy to Clipboard");
		btnCopyDNSRecord.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				copyToClipboardClick();
			}
		});
		btnCopyDNSRecord.setBounds(281, 239, 143, 23);
		contentPanel.add(btnCopyDNSRecord);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 268, 415, 119);
		contentPanel.add(scrollPane);
		
		memPrivateKey = new JTextArea();
		scrollPane.setViewportView(memPrivateKey);
		{			
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Copy to Clipboard");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						copyToClipboardKeyClick();
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Save to File");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						saveToFileClick();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	protected void copyToClipboardKeyClick() {
		if (memPrivateKey.getText().length() != 0)  setClipboardContents(memPrivateKey.getText());
	}

	protected void saveToFileClick() {
		String fileName = getSaveFileName();
		
		if (fileName.length() > 0 && memPrivateKey.getText().length() > 0) {
			try {
				BufferedWriter out = new BufferedWriter(new FileWriter(fileName));
	            out.write(memPrivateKey.getText());
	            out.close();
	        } catch (IOException e) {
	            showErrorMessage(e.getMessage(), "Error");
	        }
		}
	}
	
	private String getSaveFileName() {
		JFileChooser fc = new JFileChooser();
			    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public void setClipboardContents( String aString ){
		StringSelection stringSelection = new StringSelection( aString );
		Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		clipboard.setContents( stringSelection, null );
	}
	  
	protected void copyToClipboardClick() {
		if (edtDNSRecord.getText().length() != 0)  setClipboardContents(edtDNSRecord.getText());
	}

	protected void revokeClick() {
		TElDKDNSRecord DNS = new TElDKDNSRecord();
		DNS.setKeyGranularity(edtGranularity.getText());
		DNS.setNotes(edtNotes.getText());
		DNS.setTestMode(cbTestMode.isSelected());  // set Test Mode flag in DNS
		DNS.createPublicKey(SBDomainKeys.dkRSA);           // RSA key type is the only type is supported by now
		DNS.getPublicKey().revoke();                 // set Revoked flag in DNS
		// clear controls
		edtDNSRecord.setText("");
		memPrivateKey.setText("");
		// generate DNS record
		TSBString S = new TSBString();
		int Result = DNS.save(S);
		if (Result == SBDomainKeys.SB_DK_DNS_ERROR_SUCCESS)
			edtDNSRecord.setText(S.value);
		else
			showErrorMessage("Failed to generate a DNS record", "Error");
	}

	protected void generateClick() {
		TElDKDNSRecord DNS = new TElDKDNSRecord();
		TSBInteger KeySize = new TSBInteger();
		KeySize.value = (Integer)trkPublicKeySize.getValue();
		try
		{
			DNS.setKeyGranularity(edtGranularity.getText());
			DNS.setNotes(edtNotes.getText());
			DNS.setTestMode(cbTestMode.isSelected());				// Set Test Mode flag in DNS
			DNS.createPublicKey(SBDomainKeys.dkRSA);	// RSA key type is the only type is supported by now
			// generate public and private keys
			TElDKRSAPublicKey PublicKey = (TElDKRSAPublicKey)DNS.getPublicKey();
			byte[] PrivateKey = null;

			if ((PrivateKey = PublicKey.generate(KeySize.value)) == null)
			{
				showErrorMessage("Failed to generate public and private keys","Error");
				return;
			}
			edtDNSRecord.setText("");
			memPrivateKey.setText("");
			TSBString S = new TSBString();
			int Result = DNS.save(S);
			if (Result==SBDomainKeys.SB_DK_DNS_ERROR_SUCCESS)
				edtDNSRecord.setText(S.value);
			else
				showErrorMessage("Failed to generate a DNS record", "Error");
			// convert the private key to PEM format
			KeySize.value = -1;
			byte[] SavedKey = null;
			SBPEM.encode(PrivateKey, SavedKey, KeySize,"RSA PRIVATE KEY", false, "");
			SavedKey = new byte[KeySize.value];
			SBPEM.encode(PrivateKey, SavedKey, KeySize,"RSA PRIVATE KEY", false, "");
			if (KeySize.value == 0)
				showErrorMessage("Failed to convert the private key","Error");
			memPrivateKey.setText(new String(SavedKey));
		} catch(Exception exc) {
			showErrorMessage(exc.getMessage(), "Error");
		}
	}

	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);		
	}

	private void fillSlider() {
	    Hashtable<Integer, JLabel> table = new Hashtable<Integer, JLabel>();
	    
	    int i = 256;
	    while (i < 4096 + 1) {
	    	boolean printLabel = (((i / 256) % 4 == 0) || (i == 256));
	    	String label = printLabel ? i + "" : "";
	    	table.put(i, new JLabel(label));
	    	i += 256;
	    }
	    
	    trkPublicKeySize.setLabelTable(table);
	}

	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
	}
}

