import java.awt.BorderLayout;
import javax.swing.JPanel;
import java.awt.Dimension;
import javax.swing.border.TitledBorder;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JCheckBox;

import SecureBlackbox.Base.SBChSConv;
import SecureBlackbox.Base.TEnumCharsetsProc;
import java.awt.event.ItemListener;
import java.awt.event.ItemEvent;

public class MimeViewer_Options extends MimeViewer_PlugControl {
	private static final long serialVersionUID = 1L;
	private JComboBox<String> comboBox_HeaderCharset;
	private JComboBox<String> comboBox_BodyCharset;
	private JCheckBox checkBox_ActivatePartHandlers;
	private JCheckBox checkBox_UseBackgroundParser;
	private JCheckBox checkBox_FieldsInTree;
	private JCheckBox checkBox_HeaderInTree;
	private JCheckBox checkBox_BodyInTree;
	protected boolean fLocked = true;
	
	public MimeViewer_Options() {
		setLayout(new BorderLayout(0, 0));
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Message Parser Options", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setPreferredSize(new Dimension(10, 180));
		add(panel, BorderLayout.NORTH);
		panel.setLayout(null);
		
		JLabel lblDefaultHeaderCharset = new JLabel("Default Header Charset");
		lblDefaultHeaderCharset.setBounds(22, 31, 173, 14);
		panel.add(lblDefaultHeaderCharset);
		
		JLabel lblDefaultBodyCharset = new JLabel("Default Body Charset");
		lblDefaultBodyCharset.setBounds(205, 31, 182, 14);
		panel.add(lblDefaultBodyCharset);
		
		comboBox_HeaderCharset = new JComboBox<String>();
		comboBox_HeaderCharset.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fDefaultHeaderCharset = (String)comboBox_HeaderCharset.getSelectedItem();				
			}
		});
		comboBox_HeaderCharset.setBounds(22, 47, 158, 22);
		panel.add(comboBox_HeaderCharset);
		
		comboBox_BodyCharset = new JComboBox<String>();
		comboBox_BodyCharset.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fDefaultHeaderCharset = (String)comboBox_BodyCharset.getSelectedItem();				
			}
		});
		comboBox_BodyCharset.setBounds(205, 47, 158, 22);
		panel.add(comboBox_BodyCharset);
		
		checkBox_ActivatePartHandlers = new JCheckBox("Activate Part Handlers when loading a message");
		checkBox_ActivatePartHandlers.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fDefaultActivatePartHandlers = checkBox_ActivatePartHandlers.isSelected();				
			}
		});
		checkBox_ActivatePartHandlers.setBounds(22, 76, 390, 23);
		panel.add(checkBox_ActivatePartHandlers);
		
		checkBox_UseBackgroundParser = new JCheckBox("Parse message in background");
		checkBox_UseBackgroundParser.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fUseBackgroundParser = checkBox_UseBackgroundParser.isSelected();				
			}
		});
		checkBox_UseBackgroundParser.setBounds(22, 102, 318, 23);
		panel.add(checkBox_UseBackgroundParser);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, " View Options for parsed messages", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		add(panel_1, BorderLayout.CENTER);
		panel_1.setLayout(null);
		
		checkBox_FieldsInTree = new JCheckBox("Fields In Tree");
		checkBox_FieldsInTree.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fFieldsInTree = checkBox_FieldsInTree.isSelected();				
			}
		});
		checkBox_FieldsInTree.setBounds(20, 34, 147, 23);
		panel_1.add(checkBox_FieldsInTree);
		
		checkBox_HeaderInTree = new JCheckBox("Header In Tree");
		checkBox_HeaderInTree.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fHeaderInTree = checkBox_HeaderInTree.isSelected();				
			}
		});
		checkBox_HeaderInTree.setBounds(20, 60, 147, 23);
		panel_1.add(checkBox_HeaderInTree);
		
		checkBox_BodyInTree = new JCheckBox("Body In Tree");
		checkBox_BodyInTree.addItemListener(new ItemListener() {
			public void itemStateChanged(ItemEvent e) {
			       if ( fLocked ) return;
			       ProjectOptions.fBodyInTree = checkBox_BodyInTree.isSelected();				
			}
		});
		checkBox_BodyInTree.setBounds(20, 86, 97, 23);
		panel_1.add(checkBox_BodyInTree);
		
		init();
	}
   
    TEnumCharsetsProc.Callback enumCharsets = new TEnumCharsetsProc.Callback() {
		
		public boolean tEnumCharsetsProcCallback(String Category, String Description,
				String Name, String Aliases, Object userData) {
		       MimeViewer_Options myData = (MimeViewer_Options)userData;
		       if (myData != null){
		         myData.comboBox_HeaderCharset.addItem(Name);
		         myData.comboBox_BodyCharset.addItem(Name);
		       }
		       return false;
		}
	};

	private void init() {
	       fCaption = "MIME Options";  

	       try
	       {
	         comboBox_HeaderCharset.addItem("");
	         comboBox_BodyCharset.addItem("");

		     SBChSConv.enumCharsets(new TEnumCharsetsProc(enumCharsets), this);	  
	       }
	       finally
	       {
	       }

	       // Fill other ProjectOptions:

	       checkBox_ActivatePartHandlers.setSelected(ProjectOptions.fDefaultActivatePartHandlers);
	       checkBox_UseBackgroundParser.setSelected(ProjectOptions.fUseBackgroundParser);

	       checkBox_FieldsInTree.setSelected(ProjectOptions.fFieldsInTree);
	       checkBox_HeaderInTree.setSelected(ProjectOptions.fHeaderInTree);
	       checkBox_BodyInTree.setSelected(ProjectOptions.fBodyInTree);
	       
	       fLocked = false;
	  }
}
