

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JButton;
import javax.swing.JSpinner;
import javax.swing.SwingConstants;
import javax.swing.SpinnerNumberModel;
import javax.swing.JComboBox;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JCheckBox;
import javax.swing.JPasswordField;

import org.freepascal.rtl.TObject;

import SecureBlackbox.Base.*;
import SecureBlackbox.HTTPClient.*;
import SecureBlackbox.Mail.*;
import SecureBlackbox.MIME.*;
import SecureBlackbox.SSLCommon.*;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Date;


public class Main extends JDialog {

	private static final long serialVersionUID = 1L;
	private JTextField tbTo;
	private JTextField tbFrom;
	private JTextField tbSubject;
	private JTextField tbAttach;
	private JTextField tbAddress;
	private JTextField tbUsername;
	private JPasswordField tbPassword;
	private JCheckBox cbUseValidator;
	private JSpinner tbPort;

	final String cDemoVersion = "2011.05.31";
	private JTextArea tbBody;
	private JComboBox<String> cbSSLMode;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main dialog = new Main();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public Main() {
		setResizable(false);
		setTitle("SMTP Client Demo");
		setBounds(100, 100, 684, 371);
		getContentPane().setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(null, "Message", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 323, 287);
		getContentPane().add(panel);
		panel.setLayout(null);
		
		JLabel lblTo = new JLabel("To");
		lblTo.setBounds(10, 24, 46, 14);
		panel.add(lblTo);
		
		JLabel lblFrom = new JLabel("From");
		lblFrom.setBounds(10, 49, 46, 14);
		panel.add(lblFrom);
		
		JLabel lblSubject = new JLabel("Subject");
		lblSubject.setBounds(10, 74, 46, 14);
		panel.add(lblSubject);
		
		JLabel lblBody = new JLabel("Body");
		lblBody.setBounds(10, 110, 46, 14);
		panel.add(lblBody);
		
		JLabel lblAttachmet = new JLabel("Attachmet");
		lblAttachmet.setBounds(10, 252, 64, 14);
		panel.add(lblAttachmet);
		
		tbTo = new JTextField();
		tbTo.setBounds(62, 21, 239, 20);
		panel.add(tbTo);
		tbTo.setColumns(10);
		
		tbFrom = new JTextField();
		tbFrom.setColumns(10);
		tbFrom.setBounds(62, 46, 239, 20);
		panel.add(tbFrom);
		
		tbSubject = new JTextField();
		tbSubject.setText("There's something for you");
		tbSubject.setColumns(10);
		tbSubject.setBounds(62, 71, 239, 20);
		panel.add(tbSubject);
		
		JScrollPane scrollPane = new JScrollPane();
		scrollPane.setBounds(10, 135, 300, 97);
		panel.add(scrollPane);
		
		tbBody = new JTextArea();
		tbBody.setText("I will be happy to see you tomorrow");
		scrollPane.setViewportView(tbBody);
		
		tbAttach = new JTextField();
		tbAttach.setBounds(84, 249, 188, 20);
		panel.add(tbAttach);
		tbAttach.setColumns(10);
		
		JButton buttonBrowse = new JButton(" ");
		buttonBrowse.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				tbAttach.setText(getFileName());
			}
		});
		buttonBrowse.setBounds(282, 248, 28, 23);
		panel.add(buttonBrowse);
		
		JPanel panel_1 = new JPanel();
		panel_1.setBorder(new TitledBorder(null, "SMTP Server", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel_1.setBounds(343, 11, 323, 287);
		getContentPane().add(panel_1);
		panel_1.setLayout(null);
		
		JLabel lblServer = new JLabel("Server");
		lblServer.setBounds(10, 24, 46, 14);
		panel_1.add(lblServer);
		
		tbAddress = new JTextField();
		tbAddress.setText("smtp.gmail.com");
		tbAddress.setBounds(90, 21, 140, 20);
		panel_1.add(tbAddress);
		tbAddress.setColumns(10);
		
		JLabel lblPort = new JLabel("Port");
		lblPort.setHorizontalAlignment(SwingConstants.RIGHT);
		lblPort.setBounds(230, 24, 33, 14);
		panel_1.add(lblPort);
		
		tbPort = new JSpinner();
		tbPort.setModel(new SpinnerNumberModel(new Integer(465), null, null, new Integer(1)));
		tbPort.setBounds(267, 21, 46, 20);
		panel_1.add(tbPort);
		
		JLabel lblSslMode = new JLabel("SSL Mode");
		lblSslMode.setBounds(10, 58, 60, 14);
		panel_1.add(lblSslMode);
		
		cbSSLMode = new JComboBox<String>();
		cbSSLMode.setModel(new DefaultComboBoxModel<String>(new String[] {"No SSL", "Implicit", "Explicit"}));
		cbSSLMode.setBounds(90, 54, 140, 22);
		panel_1.add(cbSSLMode);
		
		JLabel lblUsername = new JLabel("Username");
		lblUsername.setBounds(10, 88, 60, 14);
		panel_1.add(lblUsername);
		
		tbUsername = new JTextField();
		tbUsername.setColumns(10);
		tbUsername.setBounds(90, 85, 140, 20);
		panel_1.add(tbUsername);
		
		JLabel lblPassword = new JLabel("Password");
		lblPassword.setBounds(10, 122, 60, 14);
		panel_1.add(lblPassword);
		
		tbPassword = new JPasswordField();
		tbPassword.setColumns(10);
		tbPassword.setBounds(90, 119, 140, 20);
		panel_1.add(tbPassword);
		
		cbUseValidator = new JCheckBox("<html><body><center>Use TElX509CertificateValidator component for certificate validation</center></body><html>");
		cbUseValidator.setSelected(true);
		cbUseValidator.setBounds(48, 169, 234, 70);
		panel_1.add(cbUseValidator);
		
		JButton btnSendMessage = new JButton("Send Message");
		btnSendMessage.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				sendClick();
			}
		});
		btnSendMessage.setBounds(532, 309, 134, 23);
		getContentPane().add(btnSendMessage);

		init();
	}

	protected void sendClick() {
        try
        {
            TElSMTPClient smtp = new TElSMTPClient();
            TElMessage msg = new TElMessage(false, "");
            TElMultiPartList mmp = new TElMultiPartList(msg, null);
            TElPlainTextPart body = new TElPlainTextPart();

            msg.setMainPart(mmp, false);
            body.setText(tbBody.getText());
            mmp.addPart(body);
 
            msg.getTo_().addAddress("", tbTo.getText());
            msg.getFrom().addAddress("", tbFrom.getText());
            msg.setSubject(tbSubject.getText());
            msg.setMessageID(TElMessage.generateMessageID());
            msg.setDate(new Date());

            if (tbAttach.getText().length() > 0)
            {
            	File file = new File(tbAttach.getText());
                String fileName = file.getName();
                TElMessagePart attach = new TElMessagePart(msg, mmp);
                TElFileStream fs = new TElFileStream(tbAttach.getText(), "r", true);
                TElMessageHeaderField mhf;

                mmp.addPart(attach);

                mhf = attach.getHeader().addField("Content-Type", "application/octet-stream", true);
                mhf.addParam("name", fileName);
                mhf = attach.getHeader().addField("Content-Disposition", "attachment", true);
                mhf.addParam("filename", fileName);

                attach.getHeader().addField("Content-Transfer-Encoding", "base64", true);
                attach.setData(fs, (int)fs.getLength(), false);
            }

            smtp.setOnCertificateValidate(new TSBCertificateValidateEvent(CertificateValidateEvent));
            smtp.setAddress(tbAddress.getText());
            smtp.setPort((Integer)tbPort.getValue());
            String mode = (String) cbSSLMode.getSelectedItem();
            if (mode.compareTo("No SSL") == 0)
            {
                smtp.setUseSSL(false);
            }
            else if (mode.compareTo("Implicit") == 0)
            {
                smtp.setUseSSL(true);
                smtp.setSSLMode(TSBSSLMode.smImplicit);
            }
            else
            {
                smtp.setUseSSL(true);
                smtp.setSSLMode(TSBSSLMode.smExplicit);
            }
            smtp.setUsername(tbUsername.getText());
            smtp.setPassword(new String(tbPassword.getPassword()));

            smtp.open();
            smtp.login(getDomain(tbFrom.getText()));
            smtp.send(msg);
            smtp.close(false);
        }
        catch (Exception ex)
        {
        	ex.printStackTrace();
            showErrorMessage(ex.getMessage(), "Error");
        }		
	}

	private void showErrorMessage(String msg, String cap) {
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);		
	}

	TSBCertificateValidateEvent.Callback CertificateValidateEvent = new TSBCertificateValidateEvent.Callback() {
		
		public void tsbCertificateValidateEventCallback(TObject sender, TElX509Certificate cert, TSBBoolean accept) {
            accept.value = true;
            if (cbUseValidator.isSelected())
            {
                if ((cert.getChain() == null) || (cert.getChain().getCertificate(0) == cert))
                {
                    TElX509CertificateValidator Validator = new TElX509CertificateValidator();
					TElX509CertificateValidatorResult result = new TElX509CertificateValidatorResult();
					// For proper CRL and OCSP validation please read instructions in 
					// description of ElX509CertificateValidator class in the help file
                    Validator.validateForSSL(cert, tbAddress.getText(), "", TSBHostRole.hrServer,
                                 null, false, new Date(), result );
                    if (result.Validity != TSBCertificateValidity.cvOk)
                    	accept.value = false;
                }
            }
		}
	};
	
	private void init() {
		#error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
		SBUtils.setLicenseKey("<put the key here>");
        
		SBHTTPCRL.registerHTTPCRLRetrieverFactory();
		SBHTTPOCSPClient.registerHTTPOCSPClientFactory();
	}

	String getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	private String getDomain(String email)
    {
        int p = email.indexOf('@');
        return email.substring(p + 1, email.length());
    }
}
