import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JCheckBox;


public class UpdSigDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbURL;
	private boolean isOk;
	private JCheckBox chckbxIncludeLocalRevocation;
	private JCheckBox chckbxIgnoreChainValidation;
	private JCheckBox chckbxAutomaticallyCollectRevocation;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			UpdSigDialog dialog = new UpdSigDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public UpdSigDialog() {
		setResizable(false);
		setTitle("Update signature");
		setBounds(100, 100, 375, 222);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			JLabel lblTimestampingServer = new JLabel("Timestamping server");
			lblTimestampingServer.setBounds(10, 11, 180, 14);
			contentPanel.add(lblTimestampingServer);
		}
		
		tbURL = new JTextField();
		tbURL.setText("http://");
		tbURL.setBounds(10, 36, 313, 20);
		contentPanel.add(tbURL);
		tbURL.setColumns(10);
		
		chckbxAutomaticallyCollectRevocation = new JCheckBox("Automatically collect revocation information");
		chckbxAutomaticallyCollectRevocation.setBounds(10, 63, 313, 23);
		contentPanel.add(chckbxAutomaticallyCollectRevocation);
		
		chckbxIgnoreChainValidation = new JCheckBox("Ignore chain validation errors");
		chckbxIgnoreChainValidation.setBounds(10, 89, 313, 23);
		contentPanel.add(chckbxIgnoreChainValidation);
		
		chckbxIncludeLocalRevocation = new JCheckBox("Include local revocation information");
		chckbxIncludeLocalRevocation.setBounds(10, 115, 332, 23);
		contentPanel.add(chckbxIncludeLocalRevocation);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public boolean isOK() {
		return isOk;
	}

	public boolean getIncludeLocalRevInfo() {
		return chckbxIncludeLocalRevocation.isSelected();
	}

	public boolean getAutoCollectRevInfo() {
		return chckbxAutomaticallyCollectRevocation.isSelected();
	}

	public boolean getIgnoreChainValidationErrors() {
		return chckbxIgnoreChainValidation.isSelected();
	}

	public String getTSPURL() {
		return tbURL.getText();
	}
}
