import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.JTextField;
import javax.swing.JLabel;
import javax.swing.JPasswordField;

import SecureBlackbox.Base.TElWinCertStorage;
import SecureBlackbox.Base.TElX509Certificate;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.JRadioButton;
import javax.swing.JComboBox;
import javax.swing.ButtonGroup;

public class SelCertDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private JTextField tbCert;
	private JPasswordField passwordField;
	private boolean isOk;
	private TElWinCertStorage SystemStore;
	private JRadioButton rbUseSystemCert;
	private JComboBox<String> cbSystemCerts;
	private final ButtonGroup buttonGroup = new ButtonGroup();
	private JRadioButton rbUseCertFile;
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			SelCertDialog dialog = new SelCertDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public SelCertDialog() {	
		setTitle("Select certificate");
		setBounds(100, 100, 390, 294);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		{
			tbCert = new JTextField();
			tbCert.setBounds(10, 61, 312, 20);
			contentPanel.add(tbCert);
			tbCert.setColumns(10);
		}
		{
			JButton btnBrowse = new JButton("...");
			btnBrowse.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					tbCert.setText(getCertFileName());
				}
			});
			btnBrowse.setBounds(332, 60, 37, 23);
			contentPanel.add(btnBrowse);
		}
		{
			JLabel lblCertificatePassword = new JLabel("Certificate password");
			lblCertificatePassword.setBounds(10, 92, 194, 14);
			contentPanel.add(lblCertificatePassword);
		}
		{
			passwordField = new JPasswordField();
			passwordField.setBounds(10, 113, 208, 20);
			contentPanel.add(passwordField);
		}
		{
			JLabel lblCertificateFile = new JLabel("Certificate file");
			lblCertificateFile.setBounds(10, 38, 194, 14);
			contentPanel.add(lblCertificateFile);
		}
		
		rbUseSystemCert = new JRadioButton("Use certificate from system certificate store:");
		buttonGroup.add(rbUseSystemCert);
		rbUseSystemCert.setBounds(10, 140, 359, 23);
		contentPanel.add(rbUseSystemCert);
		
		cbSystemCerts = new JComboBox<String>();
		cbSystemCerts.setBounds(10, 170, 359, 22);
		contentPanel.add(cbSystemCerts);
		{
			rbUseCertFile = new JRadioButton("Use certificate from file:");
			rbUseCertFile.setSelected(true);
			buttonGroup.add(rbUseCertFile);
			rbUseCertFile.setBounds(6, 7, 212, 23);
			contentPanel.add(rbUseCertFile);
		}
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("OK");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
		
		init();
	}

	private void init() {
		SystemStore = new TElWinCertStorage();
		RefreshSystemCertificateList();
	}
	
	protected String getCertFileName() {
		JFileChooser fc = new JFileChooser();
		
		FileNameExtensionFilter filter = new FileNameExtensionFilter("PFX files", "pfx");
	    fc.setFileFilter(filter);	
	    
	    int returnVal = fc.showSaveDialog(this);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile().getPath();

	    return "";
	}

	public boolean isOK() {
		return isOk;
	}

	public TElX509Certificate getCert() throws Exception {
		TElX509Certificate Cert = new TElX509Certificate();
		if (rbUseCertFile.isSelected()) 
		{
			try
			{
				Cert.loadFromFileAuto(tbCert.getText(), new String(passwordField.getPassword()));
			}
			catch(Exception ex)
			{
				Cert.Destroy();
				Cert = null;
				throw ex;
			}
		}
		else 
		{
			TElX509Certificate TempCert = SystemStore.getCertificate(cbSystemCerts.getSelectedIndex());
			if (TempCert != null)
			{
				Cert = new TElX509Certificate();
				TempCert.clone(Cert, true);
			}
		}
		
		return Cert;
	}

	void showErrorMessage(String msg, String cap){
		JOptionPane.showMessageDialog(null, msg, cap, JOptionPane.ERROR_MESSAGE);
	}
	
	public void RefreshSystemCertificateList() 
	{
		cbSystemCerts.removeAllItems();
		try 
		{
			SystemStore.getSystemStores().clear();
			SystemStore.getSystemStores().add("MY");
		} 
		finally 
		{
		}
		for (int i = 0; i < SystemStore.getCount(); i++) 
		{
			cbSystemCerts.addItem(SystemStore.getCertificate(i).getSubjectName().CommonName);
		}
	}

}
