import java.awt.BorderLayout;
import java.awt.FlowLayout;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.border.TitledBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.JCheckBox;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class ValOptsDialog extends JDialog {

	private static final long serialVersionUID = 1L;
	private final JPanel contentPanel = new JPanel();
	private boolean isOk;
	private JCheckBox chckbxRecVal;
	private JCheckBox chckbxPerformCompleteChain;
	private JCheckBox chckbxValidateTimeValues;
	private JCheckBox chckbxCheckRevocationStatus;
	private JCheckBox chckbxRequireTrustedTimestamps;
	private JCheckBox chckbxIgnoreLocalTimestamps;
	private JCheckBox chckbxVerifyCertificateTrust;
	private JCheckBox chckbxUseTelxcertificatevalidatorComponent;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		try {
			ValOptsDialog dialog = new ValOptsDialog();
			dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
			dialog.setVisible(true);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Create the dialog.
	 */
	public ValOptsDialog() {
		setTitle("Validation options");
		setBounds(100, 100, 428, 440);
		getContentPane().setLayout(new BorderLayout());
		contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
		getContentPane().add(contentPanel, BorderLayout.CENTER);
		contentPanel.setLayout(null);
		
		JPanel panel = new JPanel();
		panel.setBorder(new TitledBorder(new EtchedBorder(EtchedBorder.LOWERED, null, null), "Validation properties", TitledBorder.LEADING, TitledBorder.TOP, null, null));
		panel.setBounds(10, 11, 400, 358);
		contentPanel.add(panel);
		panel.setLayout(null);
		
		chckbxRecVal = new JCheckBox("Recursive validation (validate inner signatures/timestamps)");
		chckbxRecVal.setBounds(6, 19, 377, 23);
		panel.add(chckbxRecVal);
		
		chckbxPerformCompleteChain = new JCheckBox("Perform complete chain validation");
		chckbxPerformCompleteChain.setBounds(6, 61, 350, 23);
		panel.add(chckbxPerformCompleteChain);
		
		chckbxValidateTimeValues = new JCheckBox("Validate time values");
		chckbxValidateTimeValues.setBounds(6, 103, 350, 23);
		panel.add(chckbxValidateTimeValues);
		
		chckbxCheckRevocationStatus = new JCheckBox("Check revocation status of certificates");
		chckbxCheckRevocationStatus.setBounds(6, 145, 350, 23);
		panel.add(chckbxCheckRevocationStatus);
		
		chckbxRequireTrustedTimestamps = new JCheckBox("Require trusted timestamps");
		chckbxRequireTrustedTimestamps.setBounds(6, 187, 350, 23);
		panel.add(chckbxRequireTrustedTimestamps);
		
		chckbxIgnoreLocalTimestamps = new JCheckBox("Ignore local timestamps");
		chckbxIgnoreLocalTimestamps.setBounds(6, 229, 350, 23);
		panel.add(chckbxIgnoreLocalTimestamps);
		
		chckbxVerifyCertificateTrust = new JCheckBox("Verify certificate trust");
		chckbxVerifyCertificateTrust.setBounds(6, 271, 350, 23);
		panel.add(chckbxVerifyCertificateTrust);
		
		chckbxUseTelxcertificatevalidatorComponent = new JCheckBox("Use TElX509CertificateValidator component for validation");
		chckbxUseTelxcertificatevalidatorComponent.setBounds(6, 313, 350, 23);
		panel.add(chckbxUseTelxcertificatevalidatorComponent);
		{
			JPanel buttonPane = new JPanel();
			buttonPane.setLayout(new FlowLayout(FlowLayout.RIGHT));
			getContentPane().add(buttonPane, BorderLayout.SOUTH);
			{
				JButton okButton = new JButton("Validate");
				okButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						isOk = true;
						setVisible(false);
					}
				});
				okButton.setActionCommand("OK");
				buttonPane.add(okButton);
				getRootPane().setDefaultButton(okButton);
			}
			{
				JButton cancelButton = new JButton("Cancel");
				cancelButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						dispose();
					}
				});
				cancelButton.setActionCommand("Cancel");
				buttonPane.add(cancelButton);
			}
		}
	}

	public boolean isOK() {
		return isOk;
	}

	public boolean getRecursiveValidation() {
		return chckbxRecVal.isSelected();
	}

	public boolean getValidateChains() {
		return chckbxPerformCompleteChain.isSelected();
	}

	public boolean getValidateTimes() {
		return chckbxValidateTimeValues.isSelected();
	}

	public boolean getCheckRevocationStatus() {
		return chckbxCheckRevocationStatus.isSelected();
	}

	public boolean getRequireTimestamps() {
		return chckbxRequireTrustedTimestamps.isSelected();
	}

	public boolean getIgnoreLocalTimestamps() {
		return chckbxIgnoreLocalTimestamps.isSelected();
	}

	public boolean getValidateTrusts() {
		return chckbxVerifyCertificateTrust.isSelected();
	}

	public boolean getUseCertValidator() {
		return chckbxUseTelxcertificatevalidatorComponent.isSelected();
	}
}