import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.SFTPCommon.*;


public class FilesDataRow {

	public String Name;
	public String Size;
	public String Modif;
	public String Owner;
	public String Rights;
	public TElSftpFileInfo Tag;
	
	public FilesDataRow(TElSftpFileInfo info) {
		Tag = info;
		
		Name = info.getName();
		if (!info.getAttributes().getDirectory()) 
			Size = info.getAttributes().getSize() + "";

		Modif = info.getAttributes().getMTime().toString();
		Owner = SBUtils.stringOfBytes(info.getAttributes().getOwner());
		Rights = formatRights(info.getAttributes());
	}
	
	private String formatRights(TElSftpFileAttributes attributes)
	{
		String res = "";
		if (attributes.getDirectory()) 
		{
			res = res + "d";
		}
		if (attributes.getUserRead()) 
		{
			res = res + "r";
		} 
		else 
		{
			res = res + "-";
		}
		if (attributes.getUserWrite()) 
		{
			res = res + "w";
		}
		else 
		{
			res = res + "-";
		}
		if (attributes.getUserExecute()) 
		{
			res = res + "x";
		}
		else 
		{
			res = res + "-";
		}
		if (attributes.getGroupRead()) 
		{
			res = res + 'r';
		}
		else 
		{
			res = res + '-';
		}
		if (attributes.getGroupWrite()) 
		{
			res = res + 'w';
		}
		else 
		{
			res = res + '-';
		}
		if (attributes.getGroupExecute()) 
		{
			res = res + 'x';
		}
		else 
		{
			res = res + '-';
		}
		if (attributes.getOtherRead()) 
		{
			res = res + 'r';
		}
		else 
		{
			res = res + '-';
		}
		if (attributes.getOtherWrite()) 
		{
			res = res + 'w';
		}
		else 
		{
			res = res + '-';
		}
		if (attributes.getOtherExecute()) 
		{
			res = res + 'x';
		}
		else 
		{
			res = res + '-';
		}
		return res;
	}
}
