
class ManualResetEvent {

	private final Object monitor = new Object();
	private volatile boolean open = false;

	public ManualResetEvent(boolean open) {
		this.open = open;
	}

	public boolean waitOne() {
		synchronized (monitor) {
			while (open == false) {
				try {
					monitor.wait();
				} catch (InterruptedException e) {
					return false;
				}
			}
			return true;
		}
	}

	public void set() {
		open();
	}
	  
	public void open() {
		synchronized (monitor) {
			open = true;
			monitor.notifyAll();
		}
	}

	public void close()  {
		open = false;
	}

	public void reset() {
		close();
	}
}