import java.util.Vector;
import javax.swing.table.AbstractTableModel;

import SecureBlackbox.Base.TElStringList;

public class UserTableModel extends AbstractTableModel {

	public static final int USER_INDEX = 0;
    public static final int PASS_INDEX = 1;
    
	private static final long serialVersionUID = 1L;
    protected String[] columnNames = {"Username", "Password" };
    protected Vector<UserDataRow> dataVector = new Vector<UserDataRow>();
    
 	public String getColumnName(int column) {
        return columnNames[column];
    }
 	
	public int getColumnCount() {
		return columnNames.length;
	}

	public int getRowCount() {
        return dataVector.size();
	}

	public Object getValueAt(int row, int col) {
        UserDataRow record = (UserDataRow)dataVector.get(row);
        switch (col) {
            case USER_INDEX:
               return record.Name;
            case PASS_INDEX:
               return record.Pass;
            default:
               return new Object();
        }
	}

 	public Class<?> getColumnClass(int column) {
        switch (column) {
            case USER_INDEX:
            case PASS_INDEX:
            	return String.class;
            default:
               return Object.class;
        }
    }
 	
    public void setValueAt(Object value, int row, int column) {
   	 UserDataRow record = (UserDataRow)dataVector.get(row);
        switch (column) {
            case USER_INDEX:
               record.Name = (String)value;
               break;
            case PASS_INDEX:
               record.Pass = (String)value;
               break;
            default:
               System.out.println("invalid index");
        }
        fireTableCellUpdated(row, column);
    } 	
    
 	public void addRow(String name, String pass){
		dataVector.add(new UserDataRow(name, pass)); 			
		fireTableDataChanged();
 	}

	public void clear() {
		dataVector.clear();
		fireTableDataChanged();
	}

	public void remove(int selectedRow) {
		dataVector.remove(selectedRow);
		fireTableDataChanged();
	}

	public TElStringList getUsers() {
        TElStringList res = new TElStringList();
        for (int i = 0; i < dataVector.size(); i++) {
        	String name = dataVector.get(i).Name;
        	String pass = dataVector.get(i).Pass;
            res.add(name, pass);
        }
		return res;
	}
}