
import SecureBlackbox.Base.SBChSConv;
import SecureBlackbox.Base.SBChSConvCharsets;
import SecureBlackbox.Base.SBUtils;
import SecureBlackbox.Base.TSBBoolean;
import SecureBlackbox.Base.TSBInteger;
import SecureBlackbox.ZIP.*;
import org.freepascal.rtl.TObject;

import javax.swing.*;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

public class Main {

	private JFrame frmBZip2Archivier;
    private final JPanel contentPanel = new JPanel();
    private JTextField textArchiveName;
    private JTextField textArchiveSize;

    private JButton btnClose;
    private JButton btnAdd;
    private JButton btnExtract;
    private JButton btnSave;
    private JButton btnSaveAs;

    String extractToFile;
	TElBZip2Writer elBZip2Writer;

	String newArchiveName;
    String saveArchiveName;
	String openedArchiveName;

	ProgressDialog progressForm;	
	
	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					Main window = new Main();
					window.frmBZip2Archivier.setVisible(true);
				} catch (Exception e) {
					showErrorMessage("Error", e.getMessage());
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public Main() {
		initialize();
		initGZipWriterEvents();
	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize() {
        #error Please pick the evaluation license key from <SecureBlackbox>\LicenseKey.txt file and place it here. If the evaluation key expires, you can request an extension using the form on https://www.eldos.com/sbb/keyreq/
        SBUtils.setLicenseKey("<put the key here>");

 		SBChSConvCharsets.initialize();

        elBZip2Writer = new TElBZip2Writer();

        frmBZip2Archivier = new JFrame();
        frmBZip2Archivier.setTitle("GZip Archivier");
        frmBZip2Archivier.setBounds(100, 100, 485, 290);
        frmBZip2Archivier.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frmBZip2Archivier.getContentPane().setLayout(new BorderLayout());
        contentPanel.setBorder(new EmptyBorder(5, 5, 5, 5));
        frmBZip2Archivier.getContentPane().add(contentPanel, BorderLayout.CENTER);
        contentPanel.setLayout(null);

        JButton btnNew = new JButton("New archive");
        btnNew.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                newArchive();
            }
        });
        btnNew.setBounds(20, 20, 110, 30);
        contentPanel.add(btnNew);

        JButton btnOpen = new JButton("Open archive");
        btnOpen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                openArchive();
            }
        });
        btnOpen.setBounds(140, 20, 110, 30);
        contentPanel.add(btnOpen);

        btnClose = new JButton("Close archive");
        btnClose.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                closeArchive();
            }
        });
        btnClose.setBounds(345, 20, 115, 30);
        btnClose.setEnabled(false);
        contentPanel.add(btnClose);

        JLabel lblArchiveName = new JLabel("Archive name");
        lblArchiveName.setBounds(20, 70, 80, 13);
        contentPanel.add(lblArchiveName);

        textArchiveName = new JTextField();
        textArchiveName.setBounds(105, 67, 249, 20);
        textArchiveName.setEditable(false);
        contentPanel.add(textArchiveName);

        JLabel lblArchiveSize = new JLabel("Archive size");
        lblArchiveSize.setBounds(28, 114, 80, 13);
        contentPanel.add(lblArchiveSize);

        textArchiveSize = new JTextField();
        textArchiveSize.setBounds(105, 111, 47, 20);
        textArchiveSize.setEditable(false);
        contentPanel.add(textArchiveSize);

        btnAdd = new JButton("Add file");
        btnAdd.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                addFileToArchive();
            }
        });
        btnAdd.setBounds(20, 164, 80, 30);
        btnAdd.setEnabled(false);
        contentPanel.add(btnAdd);

        btnExtract = new JButton("Extract to");
        btnExtract.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                File fileName = getFileSaveAsName();
                if (fileName != null)
                  extractFile(fileName.getPath());
            }
        });
        btnExtract.setBounds(220, 164, 110, 30);
        btnExtract.setEnabled(false);
        contentPanel.add(btnExtract);

        btnSave = new JButton("Compress");
        btnSave.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                saveArchive();
            }
        });
        btnSave.setBounds(20, 215, 110, 30);
        btnSave.setEnabled(false);
        contentPanel.add(btnSave);

        btnSaveAs = new JButton("Compress as");
        btnSaveAs.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                saveArchiveAs();
            }
        });
        btnSaveAs.setBounds(150, 215, 140, 30);
        btnSaveAs.setEnabled(false);
        contentPanel.add(btnSaveAs);
	}

	private void initGZipWriterEvents() {
        elBZip2Writer.setOnUserActionNeeded(new TSBBzip2UserActionNeededEvent(actionClbk));
        elBZip2Writer.setOnProgress(new TSBBzip2ProgressEvent(progressClbk));
	}

	private void addFileToArchive() {
		File file = getFileName();

        if (file != null)
        {
            elBZip2Writer.add(file.getPath());

            btnSave.setEnabled(true);
            btnSaveAs.setEnabled(true);
        }
	}

	File getFileName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showOpenDialog(frmBZip2Archivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile();

	    return null;
	} 

	File getFileSaveAsName(){
		JFileChooser fc = new JFileChooser();

	    int returnVal = fc.showSaveDialog(frmBZip2Archivier);
		if (returnVal == JFileChooser.APPROVE_OPTION)
	        return fc.getSelectedFile();

	    return null;
	}

	private void openArchive() {
        if (elBZip2Writer.getOpened())
            elBZip2Writer.close();

        File fileName = getFileName();
        if (fileName != null)
        {
            openedArchiveName = fileName.getPath();

            java.lang.Thread t = new java.lang.Thread(new Runnable() {
                public void run() {
                    try
                    {
                        elBZip2Writer.open(openedArchiveName, false);
                    }
                    catch (Exception ex)
                    {
                        showErrorMessage("Error opening archive", ex.getMessage());
                    }

                    if (elBZip2Writer.getOpened())
                    {
                        btnClose.setEnabled(true);
                        btnAdd.setEnabled(true);
                        btnExtract.setEnabled(true);

                        textArchiveName.setText(openedArchiveName);
                        textArchiveSize.setText(Long.toString(elBZip2Writer.getCompressedSize()));
                    };
                }
            });

            t.start();
        }
	}

	static void showErrorMessage(String caption, String msg){
		JOptionPane.showMessageDialog(null, msg, caption, JOptionPane.ERROR_MESSAGE);
	}
	
	private void closeArchive() {
		if (elBZip2Writer.getOpened())
		{
            elBZip2Writer.close();

            btnClose.setEnabled(false);
            btnAdd.setEnabled(false);
            btnSave.setEnabled(false);
            btnSaveAs.setEnabled(false);
            btnExtract.setEnabled(false);

            textArchiveName.setText("");
            textArchiveSize.setText("");
		}
	}

	private void createNewArchive(ArchiveOptionsDialog src) {
        newArchiveName = src.getNewArchiveFullPath();

        elBZip2Writer.createArchive();

        elBZip2Writer.setCompressionLevel(src.getCompressionLevel());

        btnClose.setEnabled(true);
        btnAdd.setEnabled(true);

        textArchiveName.setText(newArchiveName);
		textArchiveSize.setText("0");

		addFileToArchive();
	}

	private void newArchive() {
		closeArchive();
		
		ArchiveOptionsDialog dlg = new ArchiveOptionsDialog();
		dlg.setModal(true);
		dlg.setVisible(true);
		if (dlg.getIsCreateArch())
			createNewArchive(dlg);
	}

	private void saveArchiveAs() {
		saveArchiveName = getFileSaveAsName().getPath();

        if (saveArchiveName != "") {
            progressForm = new ProgressDialog();

            progressForm.setCaptionText("Compressing...");
            progressForm.setButtonOKEnabled(false);
            progressForm.setButtonCancelEnabled(true);
            progressForm.setCancelOperation(false);

            progressForm.setCurrentFileName(saveArchiveName);
            progressForm.setProgressBarCurrentFile(0);

            progressForm.setVisible(true);

            java.lang.Thread t = new java.lang.Thread(new Runnable() {
                public void run() {
                    try
                    {
                        elBZip2Writer.compress(saveArchiveName);

                        textArchiveSize.setText(Long.toString(elBZip2Writer.getCompressedSize()));
                        progressForm.addToLog("File compressed : " + saveArchiveName);
                    }
                    catch (Exception ex)
                    {
                        showErrorMessage("Compression error", ex.getMessage());
                    }
                    finally
                    {
                        progressForm.setButtonCancelEnabled(false);
                        progressForm.setButtonOKEnabled(true);
                    }
                }
            });

            t.start();
        }
	}
	
	private void saveArchive() {
		
		progressForm = new ProgressDialog();

		progressForm.setCaptionText("Compressing...");
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);

        if (elBZip2Writer.getNewArchive())
            progressForm.setCurrentFileName(newArchiveName);
        else
            progressForm.setCurrentFileName(openedArchiveName);
        progressForm.setProgressBarCurrentFile(0);

		progressForm.setVisible(true);
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
					if (elBZip2Writer.getNewArchive())
                        elBZip2Writer.compress(newArchiveName);
			        else
                        elBZip2Writer.compress();

                    textArchiveSize.setText(Long.toString(elBZip2Writer.getCompressedSize()));

                    if (elBZip2Writer.getNewArchive())
                        progressForm.addToLog("File compressed : " + newArchiveName);
                    else
                        progressForm.addToLog("File compressed : " + openedArchiveName);
				}
				catch (Exception ex)
				{
					showErrorMessage("Compression error", ex.getMessage());
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
			}
		});
		
		t.start();
	}
	

	private void extractFile(String outputFile)
	{
		progressForm = new ProgressDialog();
		progressForm.setButtonOKEnabled(false);
		progressForm.setButtonCancelEnabled(true);
		progressForm.setCancelOperation(false);
		progressForm.clearLog();
		progressForm.setCaptionText("Extracting...");

        progressForm.setCurrentFileName(outputFile);
        progressForm.setProgressBarCurrentFile(0);

		progressForm.setVisible(true);

        extractToFile = outputFile;
		
		java.lang.Thread t = new java.lang.Thread(new Runnable() {
			public void run() {
				try
				{
                    elBZip2Writer.extract(extractToFile);
                    progressForm.addToLog("File extract : " + extractToFile);
				}
				catch (Exception ex)
				{
					progressForm.addToLog("Error extracting file: " + ex.getMessage());                
				}
				finally
				{
					progressForm.setButtonCancelEnabled(false);
					progressForm.setButtonOKEnabled(true);
				}
			}
		});
		
		t.start();
	}

	private int selectUserAction(String description) {
		int result = JOptionPane.showOptionDialog(null, description, "Warning", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE, null, new String[] { "Abort", "Retry", "Ignore" }, null);
		
		if (result == 0)
			return SBArcTar.TAR_ACTION_ABORT;
		else if (result == 1)
			return SBArcTar.TAR_ACTION_RETRY;

		return SBArcTar.TAR_ACTION_IGNORE;
	}
	
	// events
	
	TSBBzip2UserActionNeededEvent.Callback actionClbk = new TSBBzip2UserActionNeededEvent.Callback() {
		public void tsbBzip2UserActionNeededEventCallback(TObject sender, int forEvent, String description, TSBInteger action) {
			action.value = selectUserAction(description);
		}
	};
	
	TSBBzip2ProgressEvent.Callback progressClbk = new TSBBzip2ProgressEvent.Callback() {
		public void tsbBzip2ProgressEventCallback(TObject sender, long processed, long total, TSBBoolean cancel) {
			long processedNorm;
            if (total > 0)
                processedNorm = ((processed * 100000) / total);
            else
                processedNorm = 100000;
			progressForm.setProgressBarCurrentFile((int) processedNorm);

			cancel.value = progressForm.getCancelOperation();
		}
	};
}